/* package-info.java
   Copyright (C) 2014 Red Hat, Inc.

This file is part of IcedTea.

IcedTea is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation, version 2.

IcedTea is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
IcedTea; see the file COPYING. If not, write to the
Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301 USA.

Linking this library statically or dynamically with other modules is making a
combined work based on this library. Thus, the terms and conditions of the GNU
General Public License cover the whole combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent modules, and
to copy and distribute the resulting executable under terms of your choice,
provided that you also meet, for each linked independent module, the terms and
conditions of the license of that module. An independent module is a module
which is not derived from or based on this library. If you modify this library,
you may extend this exception to your version of the library, but you are not
obligated to do so. If you do not wish to do so, delete this exception
statement from your version.*/
/**
 * This package contains the classes that represent the parts of a Java Network
 * Launching Protocol (JNLP) file as objects, and a way to launch a JNLP file
 * as an application, applet, or installer.
 *
 * <h2>Package Specification</h2>
 * <ul>
 *   <li><a href="http://java.sun.com/products/javawebstart/download-spec.html">JNLP specification</a>
 * </ul>
 * <h2>Related Documentation</h2>
 * For overviews, tutorials, examples, guides, and tool documentation, please see:
 * @see <a href="https://jcp.org/en/jsr/detail?id=56">JSR56: Java Network Launching Protocol and API</a>
 * @see <a href="http://jnlp.sourceforge.net/netx/">Netx JNLP Client</a>
 * @see <a href="http://www.oracle.com/technetwork/java/javase/javawebstart">Java Web Start JNLP Client</a>
 */
package net.sourceforge.jnlp;
